import React, { Component } from 'react';
import { BrowserRouter as Router, Route, Switch } from 'react-router-dom';
import axios from 'axios';
import {
  Callback,
  NotAuthenticated,
  NotAuthorized,
  Authenticating,
} from './DefaultAuthComponents/AuthDefaultComps';
import {
  AuthenticationProvider,
  AuthenticationContext,
  InMemorySWebStorage,
  withOidcSecure
} from '@axa-fr/react-oidc-context';

export class SecuredRouteWrap extends Component {
  constructor(props){
    super(props);
    this.state = {
      securedChildren : [],
      oidcUser : undefined,
      provider : this.buildProvider()
    }
    this.buildSecureChildren = this.buildSecureChildren.bind(this)
    this.buildProvider = this.buildProvider.bind(this)
  }

  buildProvider(){
    // const provider = React.createElement(AuthenticationProvider, {
      // configuration : this.props.oidc,
      // loggerLevel : this.props.oidc.DEBUG,
      // isEnabled : true,
      // callbackComponentOverride : Callback,
      // UserStore : InMemorySWebStorage,
      // notAuthenticated : NotAuthenticated, 
      // notAuthorized : NotAuthorized,
      // authenticating : Authenticating
    // }, <div>hello world</div>)
    // return  provider 

    const _prov = <AuthenticationProvider
      configuration={this.props.oidc}
      loggerLevel={this.props.oidc.DEBUG}
      isEnabled={true}
      callbackComponentOverride={Callback}
      UserStore={InMemorySWebStorage}
      notAuthenticated={NotAuthenticated}
      notAuthorized={NotAuthorized}
      authenticating={Authenticating}
    />

    // const provider = React.createElement(new AuthenticationProvider({
    //   configuration : this.props.oidc,
    //   loggerLevel : this.props.oidc.DEBUG,
    //   isEnabled : true,
    //   callbackComponentOverride : Callback,
    //   UserStore : InMemorySWebStorage,
    //   notAuthenticated : NotAuthenticated, 
    //   notAuthorized : NotAuthorized,
    //   authenticating : Authenticating
    // }) , <span>hello world</span>)
    return _prov
  }
   
    // }

    componentDidMount(){
      // this.buildSecureChildren()
      // console.log(this.props.context, 'heres the props for oidc context')
    }

    componentWillReceiveProps(props){
      // if(props.context.oidcUser !== undefined || props.context.oidcUser !== null){
      //   this.setState({
      //     oidcUser : props.context.oidcUser
      //   })
      // }
      console.log(props)
    }

    buildSecureChildren(){
      let childrenElements = [];
      React.Children.map(this.props.children, (child) => {
          childrenElements.push(child);
      })
      childrenElements.map((ele, index) => {
        console.log(ele.props, "ele props")
        let secureComponent = withOidcSecure(ele.type);
        let compInstance = secureComponent(Object.assign({key: index}, ele.props) );
        return compInstance;
      })
      this.setState({
        securedChildren : childrenElements
      })
    }

    render() {
      return (
        <React.Fragment>
          {this.state.provider}
        </React.Fragment>

        // <AuthenticationProvider
        //   configuration={this.props.oidc}
        //   loggerLevel={this.props.oidc.DEBUG}
        //   isEnabled={true}
        //   callbackComponentOverride={Callback}
        //   UserStore={InMemorySWebStorage}
        //   notAuthenticated={NotAuthenticated}
        //   notAuthorized={NotAuthorized}
        //   authenticating={Authenticating}
        // >
        //   <AuthenticationContext.Consumer>
        //     { context => 
        //     <Router>
        //         <Switch>
        //             {this.state.securedChildren.map((ele) => {
        //                 return ele;
        //             })}
        //         </Switch>
        //     </Router>
        //     }
        //   </AuthenticationContext.Consumer> 
        //   </AuthenticationProvider>
        
        // <React.Fragment>
          
        // {/* </React.Fragment> */}
      );
    }
}

export default SecuredRouteWrap;