import React, { Component } from 'react';
import { BrowserRouter as Router, Route, Switch } from 'react-router-dom';
import axios from 'axios';
import {
  Callback,
  NotAuthenticated,
  NotAuthorized,
  Authenticating,
} from './DefaultAuthComponents/AuthDefaultComps';
import {
  AuthenticationProvider,
  AuthenticationContext,
  InMemorySWebStorage,
  withOidcSecure
} from '@axa-fr/react-oidc-context';

export class SecuredRouteWrapV1 extends Component {
  constructor(props){
    super(props);
    this.state = {
      securedChildren : [],
    //   oidcUser : undefined,
    }
    this.buildSecureChildren = this.buildSecureChildren.bind(this)
  }
   
    // }

    componentDidMount(){
    //   this.buildSecureChildren()
      // console.log(this.props.context, 'heres the props for oidc context')
    }

    componentWillReceiveProps(props){
      // if(props.context.oidcUser !== undefined || props.context.oidcUser !== null){
      //   this.setState({
      //     oidcUser : props.context.oidcUser
      //   })
      // }
      console.log(props)
    }

    buildSecureChildren(){
      let childrenElements = [];
      React.Children.map(this.props.children, (child) => {
          childrenElements.push(child);
      })
      childrenElements.map((ele, index) => {
        console.log(ele.props, "ele props")
        let secureComponent = withOidcSecure(ele.type);
        let compInstance = secureComponent(Object.assign({key: index}, ele.props) );
        return compInstance;
      })
      this.setState({
        securedChildren : childrenElements
      })
    }

    render() {
        let childrenElement = [];
        React.Children.map(this.props.children, (child) => {
            childrenElement.push(child);
        });

      return (
          
            <Router>
                <Switch>
                    {childrenElement.map((ele, index) => {
                        let secureComponent = withOidcSecure(ele.type);
                        let compInstance = secureComponent(Object.assign({key: index}, ele.props) );
                        return compInstance;
                    })}
                </Switch>
            </Router>
      );
    }
}

export default SecuredRouteWrapV1;